use cgmath::{Deg, Point3};

use galactica_content as content;
use galactica_render::ObjectSprite;

pub struct SystemObject {
	pub sprite: content::SpriteHandle,
	pub pos: Point3<f32>,
	pub size: f32,
	pub angle: Deg<f32>,
}

impl SystemObject {
	pub(crate) fn get_sprite(&self) -> ObjectSprite {
		return ObjectSprite {
			sprite: self.sprite,
			pos: self.pos,
			angle: self.angle,
			size: self.size,
			children: None,
		};
	}
}
